/* ============================================================
 *
 * This file is a part of RCI project
 *
 * Copyright (C) 2011 by Arne Nordmann <anordman at cor-lab dot uni-bielefeld dot de>
 *
 * This file may be licensed under the terms of the
 * GNU Lesser General Public License Version 3 (the ``LGPL''),
 * or (at your option) any later version.
 *
 * Software distributed under the License is distributed
 * on an ``AS IS'' basis, WITHOUT WARRANTY OF ANY KIND, either
 * express or implied. See the LGPL for the specific language
 * governing rights and limitations.
 *
 * You should have received a copy of the LGPL along with this
 * program. If not, go to http://www.gnu.org/licenses/lgpl.html
 * or write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * The development of this software was supported by:
 *   CoR-Lab, Research Institute for Cognition and Robotics
 *     Bielefeld University
 *
 * ============================================================ */

#include "Synchronizer.h"

using namespace std;

namespace rci {

Synchronizer::Synchronizer(const std::string &sname) :
    _onlyReceive(true), busy(false), name(sname) {
}

Synchronizer::~Synchronizer() {
}

void Synchronizer::process() {
    this->processAsync();
    this->waitForProcessAsync();
}

bool Synchronizer::start() {
    this->busy = true;
    return true;
}

bool Synchronizer::stop() {
    this->busy = false;
    return true;
}

bool Synchronizer::tooBusy() const {
    return this->busy;
}

}
