#!/bin/sh

set -e

WORKDIR=$(mktemp -d)
trap "rm -rf $WORKDIR" 0 INT QUIT ABRT PIPE TERM
cd $WORKDIR
cat <<EOF > librcitest.c
#include <rci/ResourceNode.h>
#include <rci/dto/JointAngles.h>

using namespace rci;

int main()
{
    ResourceNode n();
    JointAnglesPtr ja = JointAngles::create(1);
    return 0;
}
EOF

g++ -o librcitest librcitest.c `pkg-config --cflags --libs rci0.4`
echo "build: OK"
[ -x librcitest ]
./librcitest
echo "run: OK"
