#include <gtest/gtest.h>

#include <iostream>
#include <math.h>
#include <boost/shared_ptr.hpp>

#include "rci/ResourceNode.h"
#include "rci/Controlled.h"

using namespace nemo;
using namespace rci;

class TestNode2: public ResourceNode,
        Controlled,
        PositionControlled,
        VelocityControlled,
        ImpedanceControlled {
public:
    TestNode2() :
            ResourceNode("Test node"), Controlled() {
    }
    virtual ~TestNode2() {
    }
    virtual bool setJointPosition(rci::JointAnglesPtr) {
        return false;
    }
    virtual bool setJointVelocity(rci::JointVelocitiesPtr) {
        return false;
    }
    virtual bool setJointImpedance(rci::JointImpedancePtr) {
        return false;
    }
    virtual bool isConverged() const {
        return false;
    }
    virtual void onProcess() {
        //
    }
};

class ControlledNodeTest2: public ::testing::Test {
protected:

    ControlledNodeTest2() :
            rn() {
    }

    virtual ~ControlledNodeTest2() {
    }

    TestNode2 rn;
};

TEST_F(ControlledNodeTest2, testInitialization)
{
    TestNode2 *foo = new TestNode2();
    foo->isConverged();
}
